org.cpsolver.studentsct.heuristics.selection

## Class RandomUnassignmentSelection

- java.lang.Object
- - org.cpsolver.studentsct.heuristics.selection.RandomUnassignmentSelection

- All Implemented Interfaces:
    NeighbourSelection<Request,Enrollment>
  Direct Known Subclasses:
    RndUnProblStudSelection

      public class RandomUnassignmentSelection
      extends Object
      implements NeighbourSelection<Request,Enrollment>

  Random unassignment of some (randomly selected) students.
  In each step a student is randomly selected with the given probabilty. Null is returned otherwise (controll is passed to the following `NeighbourSelection`).
  Parameters:

  Related Solver Parameters
  Parameter | Type | Comment
  --- | --- | ---
  Neighbour.RandomUnassignmentProb | `Double` | Probability of a random selection of a student.

  Version:
    StudentSct 1.3 (Student Sectioning)
    Copyright (C) 2007 - 2014 Tomáš Müller
    muller@unitime.org
    http://muller.unitime.org
    This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.
    This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
    You should have received a copy of the GNU Lesser General Public License along with this library; if not see http://www.gnu.org/licenses/.
  Author:
    Tomáš Müller

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `RandomUnassignmentSelection.UnassignStudentNeighbour` Unassignment of all requests of a student

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected double` | `iRandom`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `RandomUnassignmentSelection(DataProperties properties)`
    `RandomUnassignmentSelection(DataProperties properties, Request.RequestPriority priority)` Constructor

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `init(Solver<Request,Enrollment> solver)` Initialization
    `Neighbour<Request,Enrollment>` | `selectNeighbour(Solution<Request,Enrollment> solution)` With the given probabilty, a student is randomly selected to be unassigned.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### iRandom

          protected double iRandom

  - ### Constructor Detail

    - #### RandomUnassignmentSelection

          public RandomUnassignmentSelection(DataProperties properties,
                                             Request.RequestPriority priority)

      Constructor
      Parameters:
        `properties` - configuration

    - #### RandomUnassignmentSelection

          public RandomUnassignmentSelection(DataProperties properties)

  - ### Method Detail

    - #### init

          public void init(Solver<Request,Enrollment> solver)

      Initialization
      Specified by:
        `init` in interface `NeighbourSelection<Request,Enrollment>`
      Parameters:
        `solver` - current solver

    - #### selectNeighbour

          public Neighbour<Request,Enrollment> selectNeighbour(Solution<Request,Enrollment> solution)

      With the given probabilty, a student is randomly selected to be unassigned. Null is returned otherwise.
      Specified by:
        `selectNeighbour` in interface `NeighbourSelection<Request,Enrollment>`
      Parameters:
        `solution` - given solution
      Returns:
        a neighbour assignment